package com.yihu.wlyy.web.doctor.record;

import com.yihu.wlyy.service.app.record.HospitalizationService;
import com.yihu.wlyy.web.BaseController;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

/**
 * Created by zhenglingfeng on 2016/10/17.
 */
@Controller
@RequestMapping(value = "/doctor/record", produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
@Api(description = "医生端-健康档案住院记录")
public class HospitalizationController extends BaseController {

    @Autowired
    private HospitalizationService hospitalizationService;
    /**
     * 获取门/急诊数据
     *
     * @return
     */

    @RequestMapping(value = "/hospitalization", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
    @ResponseBody
    @ApiOperation("获取住院记录")
    public String getHospitalizationRecord(@ApiParam(name="strSSID",value="健康卡号",defaultValue = "D56668987")
                                     @RequestParam(value="strSSID",required = true) String strSSID,
                                     @ApiParam(name="startDate",value="查询的开始日期",defaultValue = "2015-01-01")
                                     @RequestParam(value="startDate",required = true) String startDate,
                                     @ApiParam(name="endDate",value="查询的结束日期",defaultValue = "2016-10-01")
                                     @RequestParam(value="endDate",required = true) String endDate,
                                     @ApiParam(name="startNum",value="需要获取的起始行数",defaultValue = "0")
                                     @RequestParam(value="startNum",required = true) String startNum,
                                     @ApiParam(name="endNum",value="需要获取的结束的行数",defaultValue = "10")
                                     @RequestParam(value="endNum",required = true) String endNum) {
        try {
            String data = hospitalizationService.getHospitalizationRecord(strSSID, startDate, endDate, startNum, endNum);

            return write(200, "获取住院记录成功！", "data", data);
        } catch (Exception e) {
            error(e);
            return invalidUserException(e, -1, "获取住院记录成功！");
        }
    }
}
