package com.yihu.wlyy.web.doctor.record;

import com.yihu.wlyy.service.app.record.InspectionService;
import com.yihu.wlyy.web.BaseController;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.json.JSONArray;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

/**
 *
 * @author HZY
 * @vsrsion 1.0
 * Created at 2016/10/17.
 */
@Controller
@RequestMapping(value = "/doctor/patient_inspection", produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
@Api(description = "医生端- 居民检查/检验记录")
public class InspectionController extends BaseController {

    @Autowired
    private InspectionService inspectionService;

    @RequestMapping(value = "/list", method = RequestMethod.GET)
    @ResponseBody
    @ApiOperation(value = "获取检查/检验列表", produces = "application/json", notes = "获取检查/检验列表")
    public String inspectionList(
            @ApiParam(name = "strSSID", value = "健康卡号")
            @RequestParam(value = "strSSID") String strSSID,
            @ApiParam(name = "startDate", value = "查询的开始日期")
            @RequestParam(value = "startDate") String startDate,
            @ApiParam(name = "endDate", value = "查询的结束日期")
            @RequestParam(value = "endDate") String endDate,
            @ApiParam(name = "startNum", value = "需要获取的起始行数")
            @RequestParam(value = "startNum") String startNum,
            @ApiParam(name = "endNum", value = "需要获取的结束的行数")
            @RequestParam(value = "endNum") String endNum) {
        try {
            //TODO 检查/检验报告接口
            JSONArray array = inspectionService.getInspectionAndChecking(strSSID,startDate,endDate,startNum,endNum);
            return write(200, "获取检查/检验记录成功！", "data", array);
        } catch (Exception e) {
            error(e);
            return invalidUserException(e, -1, "获取检查/检验记录异常！");
        }
    }

    @RequestMapping(value = "/detail", method = RequestMethod.GET)
    @ResponseBody
    @ApiOperation(value = "获取检查/检验详情", produces = "application/json", notes = "获取检查/检验详情")
    public String inspectionDetail(
            @ApiParam(name = "strSSID", value = "健康卡号")
            @RequestParam(value = "strSSID") String strSSID,
            @ApiParam(name = "strEvent", value = "事件ID")
            @RequestParam(value = "strEvent") String strEvent,
            @ApiParam(name = "strCatalog", value = "档案类型")
            @RequestParam(value = "strCatalog") String strCatalog,
            @ApiParam(name = "strSerial", value = "该类别顺序号，默认填1")
            @RequestParam(value = "strSerial") String strSerial
    ) {
        try {
            JSONArray array = new JSONArray();
            //TODO 调用检查/检验报告接口
            return write(200, "获取检查/检验详情成功！", "data", array);
        } catch (Exception e) {
            error(e);
            return invalidUserException(e, -1, "获取检查/检验详情异常！");
        }
    }

}
