package com.yihu.wlyy.web.doctor.record;

import com.yihu.wlyy.service.app.record.OutpatientService;
import com.yihu.wlyy.web.BaseController;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

/**
 * Created by zhenglingfeng on 2016/10/17.
 */
@Controller
@RequestMapping(value = "/doctor/record", produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
@Api(description = "医生端-健康档案门/急诊记录")
public class OutpatientController extends BaseController {

    @Autowired
    private OutpatientService outpatientService;
    /**
     * 获取门/急诊数据
     *
     * @return
     */
    @ApiOperation("获取门/急诊数据")
    @RequestMapping(value = "/outpatient", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
    @ResponseBody
    public String getOutpatientRecord(
                    @ApiParam(name="strSSID", value="健康卡号")
                    @RequestParam(value = "strSSID") String strSSID,
                    @ApiParam(name="startDate", value="查询的开始日期")
                    @RequestParam(value = "startDate") String startDate,
                    @ApiParam(name="endDate", value="查询的结束日期")
                    @RequestParam(value = "endDate") String endDate,
                    @ApiParam(name="startNum", value="需要获取的起始行数")
                    @RequestParam(value = "startNum") String startNum,
                    @ApiParam(name="endNum", value="需要获取的结束的行数")
                    @RequestParam(value = "endNum") String endNum) {
        try {
            String result = outpatientService.getOutpatientRecord(strSSID,
                    startDate, endDate, startNum, endNum);
            return write(200, "获取门/急诊数据成功！", "data", result);
        } catch (Exception e) {
            error(e);
            return invalidUserException(e, -1, "获取门/急诊数据失败！");
        }
    }
}
